using System;
using System.Collections;
using UnityEngine;
using UnityEngine.Networking;

public class LoginTokenVerification : MonoBehaviour
{
    public static IEnumerator VerifyToken(string token, string client_id, Action<UserDataVerified> tokenVerifyResponse)
    {
        WWWForm form = new WWWForm();
        form.AddField("token_type", "id_token");
        form.AddField("token", token);
        form.AddField("client_id", client_id);

        UnityWebRequest www = UnityWebRequest.Post("https://now.gg/accounts/oauth2/v1/verify-token", form);
        yield return www.SendWebRequest();

        if (www.result != UnityWebRequest.Result.Success)
        {
            Debug.Log($"Error in token verification: {www.error}");
        }
        else
        {
            Debug.Log($"token verification response: {www.downloadHandler.text}");
            TokenVerification tokenVerification = JsonUtility.FromJson<TokenVerification>(www.downloadHandler.text);
            if (tokenVerifyResponse != null)
                tokenVerifyResponse(tokenVerification.userData);
        }
    }
}

[System.Serializable]
public class TokenVerification
{
    public string success;
    public string code;
    [SerializeField] private UserDataVerified decodedData;
    public UserDataVerified userData { get { return decodedData; } }
    public string msg;
}

[System.Serializable]
public class UserDataVerified
{
    public string iss;
    public string sub;
    public string aud;
    public string exp;
    public string iat;
    public string auth_time;
    public string tokenId;
    public string sessionId;
    public string scope;
    public string email;
    public string name;
    public string picture;
    public string mobile;
    public string userId;
}
