using System;
using NowGG.Sdk;
using UnityEngine;
using UnityEngine.UI;

public class NowGGLoginDemo : MonoBehaviour
{
    public Text statusText;
    private string CLIENT_ID = "zBC1LCs7s7IuZzxQP9oO$$01FVCMAVCTZWJKCRPY4EH339SG";

    // Start is called before the first frame update
    void Start()
    {
        NowGGLoginSdkManager.Instance.OnLoginSuccess += OnLoginSuccess;
        NowGGLoginSdkManager.Instance.OnLoginFailed += OnLoginFailed;
    }

    private void OnLoginSuccess(string email, string token, string hostUrl)
    {
        statusText.text = "Login Success with email: " + email;

        // verify the token to get user details. We recommend verifying the token on your backend server for more security.
        StartCoroutine(LoginTokenVerification.VerifyToken(token, CLIENT_ID, TokenVerifyResponse));
    }

    private void TokenVerifyResponse(UserDataVerified userDataVerified)
    {
        Debug.Log($"User id: {userDataVerified.userId}");
        string userId = userDataVerified.userId;
        string name = userDataVerified.name;
        string email = userDataVerified.email;
        string picture = userDataVerified.picture;
        statusText.text = "email: " + email + ", userId: " + userId + ", Name: " + name;
    }

    private void OnLoginFailed(int errorCode, string errorMsg)
    {
        statusText.text = "Login Failed: " + errorMsg;

        if (errorMsg.Equals("No nowgg account present") || errorCode == 1)
            NowGGLoginSdkManager.Instance.AddNowGGAccount();
    }

    public void Login()
    {
        statusText.text = "Login....";
        NowGGLoginSdkManager.Instance.Login(CLIENT_ID);
    }
}
