using UnityEngine;
using UnityEngine.UI;
using NowGG.Sdk;
using System;
using System.Collections.Generic;
using UnityEngine.Networking;
using System.Linq.Expressions;

public class NowGGIapDemo : MonoBehaviour
{
  // QA 
  //private const String BASE_64_ENCODED_PUBLIC_KEY ="MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAw24CZt58QZiz2MvyDSMj iqCy9oM756LixVG7ShcxW7CMFCuUIj7NUnv4CEbu6MWMnDVIJHMO3M8u6zu5+Oox hPyhPdLb4+FM1RDbKlER5c+rU9zUTphAO8FvK/vAFpkVHNAmfPMi2dwCW771gRgZ rHcm+WwbmVCi5BKGq9VIpdAYTXLIxqpYh3KvUWEMeHf3PO66YEovbG5irbgB4Wtm qQyDmSpSFixxj5R7GhR/9xgUxGRdYy9BtDRChW9wnGo3vhBlnOD29ILaQ0FGvPRP Jzz5+eqkUq0rVkFeW5ZBzv8yc5RFKtBZo60Chp7sJOlP1IXzGUSHbCoIx2UDKtlC YwIDAQAB";
  private const String BASE_64_ENCODED_PUBLIC_KEY = "MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEArOr3VdaB2K+Ahy88o+/2 elDtt6HemNbidyvWuE5RBvarstqLqCGPlh6v4XhyvfqaynnO3g8EBmCWHH3BTV+S FhjPlzedcff0rKexEiV5bdmK/2U1uxvO7TxUrOihm0yH71WVDJt+Ma+Ot5XfewIO 1cWMV8x6rO/KiQ8xJ0gFR0buFZt6O1cRicXVxJS/LUbXMNzwkJKl8GhVMhT9e88Z hl/tnq0W1o5gmO625pd+3mcYBRhg59r5dK4L8s9TkjnYEY5rxP0Uh8P7ytm99MpD Pru73ZH36NeDPXXAMRSG2VNLIOxhNtUWzKfsJ7ItdqgbpMrQFuaFw1/V5ngH3utj iQIDAQAB";
  public Text statusText, coins, subs;
  public DemoProduct demoProduct;
  public DemoSubscription demoSubscription;
  public GameObject shopWindow;

  public Toggle enableGuestPayment;
  public Toggle useTestInGameID;

  public GameObject useTestInGameIDToggle;

  public HorizontalLayoutGroup productsLayoutGrp;
  private HashSet<string> activeSubs = new HashSet<string>();
  private HashSet<string> cancelledSubs = new HashSet<string>();
  private HashSet<string> deletedSubs = new HashSet<string>();
  private HashSet<string> expiredSubs = new HashSet<string>();

  private int totalCoins;
  // QA
  // private string PAYMENTS_APP_ID = "7121";

  // Prod
  private string PAYMENTS_APP_ID = "8839";

  // Start is called before the first frame update
  void Start()
  {
    if (NowGG.Sdk.NowGGPaymentsSdkManager.IsNowGGIapAvailable() == false)
    {
      Debug.Log("Not running on NowGG");
      statusText.text = "NowGG IAP not available";
      return;
    }

    NowGGPaymentsSdkManager.Instance.OnInitSuccess += OnInitSuccess;
    NowGGPaymentsSdkManager.Instance.OnInitFailed += OnInitFailed;
    NowGGPaymentsSdkManager.Instance.OnPurchaseCompleted += OnPurchaseProduct;
    NowGGPaymentsSdkManager.Instance.OnPurchaseFailed += OnPurchaseFailed;
  }

  void Update()
  {
    if (!enableGuestPayment.isOn)
    {
      useTestInGameIDToggle.SetActive(false);
    }
    else
    {
      useTestInGameIDToggle.SetActive(true);
    }
  }

  public void RemoveActiveChildren()
  {
    for (int i = productsLayoutGrp.transform.childCount - 1; i >= 0; i--)
    {
      Transform child = productsLayoutGrp.transform.GetChild(i);
      if (child.gameObject.activeInHierarchy)
      {
        Destroy(child.gameObject);
      }
    }
  }

  private void DisplaySKUItems()
  {
    try
    {
      RemoveActiveChildren();
      if (NowGGPaymentsSdkManager.Instance.products.Length == 0)
      {
        statusText.text = "No IAP products found";
        return;
      }
      // show IAP items in UI
      for (int i = 0; i < NowGGPaymentsSdkManager.Instance.products.Length; i++)
      {
        //TODO Suyog ::: This is just an example of how you'd implement consumable vs subscription
        Debug.Log("Product Type: " + NowGGPaymentsSdkManager.Instance.products[i].type);
        var productId = NowGGPaymentsSdkManager.Instance.products[i].productId;
        if (NowGGProductBuilder.Instance.GetProductType(productId) == ProductType.Consumable)
        {
          var obj = Instantiate(demoProduct, Vector3.zero, Quaternion.identity);
          obj.transform.SetParent(demoProduct.transform.parent);
          obj.gameObject.SetActive(true);
          obj.productId = NowGGPaymentsSdkManager.Instance.products[i].productId;
          obj.name.text = NowGGPaymentsSdkManager.Instance.products[i].title;
          obj.description.text = NowGGPaymentsSdkManager.Instance.products[i].description;
          obj.cost.text = NowGGPaymentsSdkManager.Instance.products[i].price;
          obj.type = NowGGPaymentsSdkManager.Instance.products[i].type;
          obj.transform.localScale = Vector3.one;
        }
        else
        {
          var obj = Instantiate(demoSubscription, Vector3.zero, Quaternion.identity);
          obj.transform.SetParent(demoSubscription.transform.parent);
          obj.gameObject.SetActive(true);
          obj.productId = NowGGPaymentsSdkManager.Instance.products[i].productId;
          obj.name.text = NowGGPaymentsSdkManager.Instance.products[i].title;
          obj.description.text = NowGGPaymentsSdkManager.Instance.products[i].description;
          obj.benefits.text = String.Join(",", NowGGPaymentsSdkManager.Instance.products[i].benefits);
          obj.cost.text = NowGGPaymentsSdkManager.Instance.products[i].price;
          obj.type = NowGGPaymentsSdkManager.Instance.products[i].type;
          obj.transform.localScale = Vector3.one;

          if (activeSubs.Contains(obj.productId))
          {
            obj.buttonText.text = "SUBSCRIBED!";
            obj.status.text = "Status: Active";
          }
          else if (cancelledSubs.Contains(obj.productId))
          {
            obj.status.text = "Status: Cancelled";
          }
          else if (deletedSubs.Contains(obj.productId))
          {
            obj.status.text = "Status: Deleted";
          }
          else if (expiredSubs.Contains(obj.productId))
          {
            obj.status.text = "Status: Expired";
          }
          else
          {
            obj.status.text = "No status";
          }
        }
      }
    }
    catch (Exception e)
    {
      Debug.Log($"SUYOG {e.StackTrace}  SUYOG1 {e.Data}");

    }
  }

  public void Init()
  {
    activeSubs.Clear();
    NowGGPaymentsSdkManager.Instance.IsInitialized = false;
    NowGGProductBuilder.Instance.Clear();
    NowGGProductBuilder.Instance.AddProduct("coin1", ProductType.Consumable);
    NowGGProductBuilder.Instance.AddProduct("coin2", ProductType.Consumable);
    NowGGProductBuilder.Instance.AddProduct("coin3", ProductType.Consumable);
    NowGGProductBuilder.Instance.AddProduct("sub1", ProductType.Subscription);
    NowGGProductBuilder.Instance.AddProduct("sub2", ProductType.Subscription);

    if (NowGGPaymentsSdkManager.IsNowGGIapAvailable() == false)
      return;

    if (enableGuestPayment.isOn)
    {
      statusText.text = "Wait..initializing as guest...";
      string inGameID = Guid.NewGuid().ToString();
      if (useTestInGameID.isOn)
      {
        inGameID = "test";
        statusText.text = "Wait..initializing as guest..., please add `test` as a payment tester to allow test payments";
      }
      NowGGPaymentsSdkManager.Instance.InitializeIap(PAYMENTS_APP_ID, inGameID);
    }
    else
    {
      statusText.text = "Wait..initializing with login...";
      NowGGPaymentsSdkManager.Instance.InitializeIap(PAYMENTS_APP_ID);
    }
  }

  private void OnInitSuccess()
  {
    if (enableGuestPayment.isOn)
    {
      statusText.text = "IAP ready..with test payments";
      if (useTestInGameID.isOn)
      {
        statusText.text = "IAP ready..with test payments and ingameId `test`";
      }
    }
    else
    {
      statusText.text = "IAP ready..with login ";
    }
    DisplaySKUItems();
  }

  private void OnInitFailed(string error)
  {
    statusText.text = "IAP init failed: " + error;
  }

  public void PurchaseProduct(string productId)
  {
    NowGGPaymentsSdkManager.Instance.PurchaseProduct(productId, "devPayloadForBuy");
  }

  public void SubscribeToProduct(string productId)
  {
    if (activeSubs.Contains(productId))
    {
      Debug.Log("Already purchased this subscription");
      return;
    }
    NowGGPaymentsSdkManager.Instance.PurchaseProduct(productId, "devPayloadForSub");
  }

  PurchaseProcessingResult OnPurchaseProduct(PurchasedProduct purchasedProduct)
  {
    // If you want to do local verification, use this sample code
    // bool isPurchaseVerified = PurchaseVerification.Instance.VerifyPurchaseLocally(BASE_64_ENCODED_PUBLIC_KEY, purchasedProduct.originalJson, purchasedProduct.signature);
    // Debug.Log("Is purchase verified: " + isPurchaseVerified);

    // We recommanded you to verify purchase on your backend server. You can send signature and originaldata to your backend server and save your public key there.
    // PurchaseVerification.Instance.VerifyValidSignatureOnBackend(purchasedProduct.originalJson, purchasedProduct.signature);

    Debug.Log($"IAP demo purchase product success: {purchasedProduct.productId}");
    Debug.Log($"This is the developer payload: {purchasedProduct.developerPayload}");
    // A consumable product has been purchased by this user.
    if (String.Equals(purchasedProduct.productId, "coin1", StringComparison.Ordinal))
    {
      Debug.Log(string.Format("OnPurchaseProduct: PASS. Product: '{0}'", purchasedProduct.productId));
      // The consumable item has been successfully purchased, add 100 coins to the player's in-game currency.
      totalCoins += 100;
    }
    else if (String.Equals(purchasedProduct.productId, "coin2", StringComparison.Ordinal))
    {
      Debug.Log(string.Format("OnPurchaseProduct: PASS. Product: '{0}'", purchasedProduct.productId));
      // The consumable item has been successfully purchased, add 200 coins to the player's in-game currency.
      totalCoins += 200;
    }
    else if (String.Equals(purchasedProduct.productId, "coin3", StringComparison.Ordinal))
    {
      Debug.Log(string.Format("OnPurchaseProduct: PASS. Product: '{0}'", purchasedProduct.productId));
      // The consumable item has been successfully purchased, add 500 coins to the player's in-game currency.
      totalCoins += 500;
    }
    else
    {
      if (purchasedProduct.subscriptionStatus == "ACTIVE")
      {
        activeSubs.Add(purchasedProduct.productId);
      }
      else if (purchasedProduct.subscriptionStatus == "CANCELLED")
      {
        cancelledSubs.Add(purchasedProduct.productId);
      }
      else if (purchasedProduct.subscriptionStatus == "DELETED")
      {
        deletedSubs.Add(purchasedProduct.productId);
      }
      else if (purchasedProduct.subscriptionStatus == "EXPIRED")
      {
        expiredSubs.Add(purchasedProduct.productId);
      }
      Debug.Log(string.Format("Subscription product: '{0}' status: '{1}'", purchasedProduct.productId, purchasedProduct.subscriptionStatus));
    }

    // Return a flag indicating whether this product has completely been received, or if the application needs 
    // to be reminded of this purchase at the next app launch.
    // return PurchaseProcessingResult.Pending if you want to be reminded of this purchase on the next launch of your game.
    // return PurchaseProcessingResult.Complete to specify that this is a one time purchase and you have allotted the equivalent in-game item to the user.
    coins.text = "Coins: " + totalCoins;
    statusText.text = "Purchase completed of id:" + purchasedProduct.productId;
    DisplaySKUItems();
    return PurchaseProcessingResult.Complete;
  }

  public void OnPurchaseFailed(int errorCode, string errorMessage)
  {
    statusText.text = "Purchase failed: " + errorMessage;
  }
}
