# to start the server, run "python startServer.py" from command line.

from BaseHTTPServer import BaseHTTPRequestHandler
import urlparse
from Crypto.Signature import pkcs1_15
from Crypto.Hash import SHA1
from Crypto.PublicKey import RSA
from base64 import b64decode,b64encode
import cgi
import json

PUBLIC_KEY = """-----BEGIN PUBLIC KEY-----
MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAwB0JndWcatG1vYeCxhM/
DPspZD+/A4MqbYTT5e4NL9u+rM7j4dVgi1MymsTf4yWrg5ErugtrZs+g+Iz0gaYu
NJX8JH6fw7Ikze2OWs6yLh9IVw9hIAuJyb8Q5gkaquqAjXK+W3q/R6O0im3whmAZ
XbTq9kCnXOo5Hs8u7TcwX+9mlFH0GZyJeF4lcKcTekX3Ayj3LMatoiLRPP3pJEPS
Xg/Q9wVzivFvcEzBla+EFUy6HFqZ/jyM99NkcCaj1CkEwZyjmtGPLKLQxwUI08N1
N7hI2VIqW4AFkHSnioeIt8pWzotrzfTXZWwrZJB5h3WWsXgUfZpPUdSnz+muXNqM
iwIDAQAB
-----END PUBLIC KEY-----"""

def verifySignature(data, signature):
        key = RSA.import_key(PUBLIC_KEY)
        sig = b64decode(signature)
        h = SHA1.new(data)
        try:
           pkcs1_15.new(key).verify(h, sig)
           print ("The signature is valid.")
           return True
        except (ValueError, TypeError):
           print ("The signature is not valid.")
           return False

class PostHandler(BaseHTTPRequestHandler):
    
    def do_POST(self):
        # Parse the form data posted
        form = cgi.FieldStorage(
            fp=self.rfile, 
            headers=self.headers,
            environ={'REQUEST_METHOD':'POST',
                     'CONTENT_TYPE':self.headers['Content-Type'],
                     })


        data = form['data'].value
        signature = form['signature'].value
        isVerified= verifySignature(data, signature)

        # Begin the response
        self.send_response(200)
        self.end_headers()
        data = {'success': isVerified}
        self.wfile.write(json.dumps(data))

        return

if __name__ == '__main__':
    from BaseHTTPServer import HTTPServer
    server = HTTPServer(('localhost', 8080), PostHandler)
    print 'Starting server, use <Ctrl-C> to stop'
    server.serve_forever()


