using System.Collections;
using System.Collections.Generic;
using NowGG.Sdk;
using TMPro;
using UnityEngine;
using UnityEngine.UI;

public class RewardedAdsSDKDemo : MonoBehaviour
{
    public Button showAdButton;
    public TMP_Text output;

    void Start()
    {
        NowGGAdsManager.Instance.OnInitSuccess += OnInitSuccess;
        NowGGAdsManager.Instance.OnInitFailed += OnInitFailed;
        NowGGAdsManager.Instance.OnNowGGRewardedAdDismissed += OnAdDismissed;
        NowGGAdsManager.Instance.OnNowGGRewardedAdFailedToLoad += OnAdFailedToLoad;
        NowGGAdsManager.Instance.OnNowGGRewardedAdShownToUser += OnAdShownToUser;
        NowGGAdsManager.Instance.OnUserEarnedReward += OnUserEarnedReward;

        // IMPORTANT this is just for debug mode, please remove this in production mode
        NowGGAdsManager.Instance.EnableDebugMode();

        Init();
    }

    private void OnInitSuccess()
    {
        output.text += "Init Success\n";
        Debug.Log("OnInitSuccess");
    }

    private void OnInitFailed(string error)
    {
        output.text += "Init Failed " + error + "\n";
        Debug.Log("OnInitFaild.. " + error);
    }

    private void OnAdShownToUser()
    {
        output.text += "OnAdShownToUser\n";
        Debug.Log("OnAdShownToUser");
    }

    private void OnAdFailedToLoad(string error)
    {
        output.text += "OnAdFailedToLoad\n";
        Debug.Log("OnAdFailedToLoad.." + error);
    }

    private void OnAdDismissed(bool rewardEarned)
    {
        output.text += "OnAdDismissed\n";
        Debug.Log("OnAdDismissed.." + rewardEarned);
    }

    private void OnUserEarnedReward()
    {
        output.text += "OnUserEarnedReward\n";
        Debug.Log("OnUserEarnedReward");
    }

    public void Init()
    {
        if (NowGGAdsManager.Instance.IsInitialized)
            return;

        output.text += "init called\n";
        Debug.Log("init called");
        NowGGAdsManager.Instance.Initialize();
    }

    public void ShowAd()
    {
        output.text += "ShowAd button clicked\n";
        NowGGAdsManager.Instance.ShowRewardedAd();
    }
}