using System;
using UnityEngine;

namespace NowGG.Sdk
{
    public class NowGGSecuritySdkManager : AndroidJavaProxy, NowGGSecuritySdkListener
    {

        public Action<bool, string, string> OnSessionToken { get; set; }

        public bool IsInitialized { get; set; }
        AndroidJavaObject nowGGAndroidJavaObj;

        private static NowGGSecuritySdkManager instance;
        public static NowGGSecuritySdkManager Instance
        {
            get
            {
                NowGGLogger.Log("Initialising NowGGSecuritySdkManager");
                if (instance == null)
                {
                    instance = new NowGGSecuritySdkManager();
                }
                return instance;
            }
        }

        public NowGGSecuritySdkManager() : base("gg.now.security.unitysdk.UnityCallBack")
        {
        }

        public void GetSessionToken()
        {

            nowGGAndroidJavaObj = new AndroidJavaObject("gg.now.security.unitysdk.NowGGSecuritySDK");
#if !UNITY_EDITOR
            AndroidJavaClass player = new  AndroidJavaClass("com.unity3d.player.UnityPlayer");
            AndroidJavaObject activity = player.GetStatic<AndroidJavaObject>("currentActivity");
            nowGGAndroidJavaObj.Call("getSessionToken", activity, this);
#else

            OnNowGGSessionToken(true, "sample token", "com.test");
#endif
        }

        public void OnNowGGSessionToken(bool success, string token, string pkgName)
        {
            NowGGLogger.Log("OnNowGGSessionToken");
            IsInitialized = true;

            if (OnSessionToken != null)
                OnSessionToken(success, token, pkgName);
        }
    }
}

public interface NowGGSecuritySdkListener
{
    void OnNowGGSessionToken(Boolean success, string token, string pkgName);
}
