using System.Collections.Generic;
using TMPro;
using UnityEngine;
using UnityEngine.SceneManagement;

public class NftShopHandler : MonoBehaviour
{
    public TMP_Text textCannyCount;
    public GameObject goConfirmPopup;

    private Dictionary<string, NftItem> nftItems = new Dictionary<string, NftItem>();

    public static NftShopHandler Instance = null;
    private void Awake()
    {
        Instance = this;
        
        nftItems.Add("1", new NftItem("1", "froggy", "https://ipfs.io/ipfs/QmYrHGJJ1qWYviBUpLb2brmVdZdQLReCZeP14sHjt2r4ZV", 300, "0x095ea7b3000000000000000000000000ff9f4c235d1508176cbe99891585e86b8fd3f09100000000000000000000000000000000000000000000001043561a8829300000"));
        nftItems.Add("2", new NftItem("2", "birdie", "https://ipfs.io/ipfs/Qmdy25RxqWxGHGKFoVD9kjuFkhyy9sm849k44v3dAu3r2A", 150, "0x095ea7b3000000000000000000000000ff9f4c235d1508176cbe99891585e86b8fd3f09100000000000000000000000000000000000000000000000821ab0d4414980000"));
        nftItems.Add("3", new NftItem("3", "penguin", "https://ipfs.io/ipfs/QmZx6pxXVPqjPiTVZFbptYMP9grQWVwMkrCDPbnE4o7H4S", 200, "0x095ea7b3000000000000000000000000ff9f4c235d1508176cbe99891585e86b8fd3f09100000000000000000000000000000000000000000000000ad78ebc5ac6200000"));
        nftItems.Add("4", new NftItem("4", "rabbie", "https://ipfs.io/ipfs/QmWrn62ippRoFRmN45WLgRfm95AdJRykL2PmFjKrtjo2nB", 50, "0x095ea7b3000000000000000000000000ff9f4c235d1508176cbe99891585e86b8fd3f091000000000000000000000000000000000000000000000002b5e3af16b1880000"));
        nftItems.Add("5", new NftItem("5", "flyie", "https://ipfs.io/ipfs/QmX6Ttu6vKUjZfcEifBLPfJknMGiGGfq5a61xKpebMNSeF", 350, "0x095ea7b3000000000000000000000000ff9f4c235d1508176cbe99891585e86b8fd3f091000000000000000000000000000000000000000000000012f939c99edab80000"));
    }

    private void Update()
    {
        textCannyCount.text = Globals.NumCannies.ToString();
    }

    public NftItem GetNftItemDetails(string nftId)
    {
        return nftItems[nftId];
    }

    public void ShowMainMenu()
    {
        SceneManager.LoadScene("MainMenu");
    }

    public void ShowConfirmationPopup(string nftId)
    {
        Debug.Log("buying: " + nftId);
        string price = nftItems[nftId].cannyPrice.ToString();

        if (Globals.NumCannies < nftItems[nftId].cannyPrice)
        {
            //todo: show pop-up to purchase canny token
        }

        Globals.CurrentlyPurchasingNftId = nftId;
        Globals.CurrentlyPurchasingNftPrice = price + " CAnnY";

        goConfirmPopup.SetActive(true);
    }

}

public class NftItem
{
    public string id;
    public string name;
    public string url;
    public int cannyPrice;
    public string data;
    public string address;

    public NftItem(string itemId, string itemName, string itemUrl,
        int itemPrice, string itemData)
    {
        id = itemId;
        name = itemName;
        url = itemUrl;
        cannyPrice = itemPrice;
        data = itemData;
        address = Constants.NftContractAddress;
    }
}

