using System;
using System.Collections;
using System.Text;
using UnityEngine;
using SimpleJSON;
using UnityEngine.Networking;

public class Utils : MonoBehaviour
{
    public static IEnumerator SendPostRequest(string url, JSONNode data, Action<string> callbackFunc)
    {
        var request = new UnityWebRequest(url, "POST");

        if (data != null)
        {
            // Debug.Log("will send data: " + data.ToString());
            byte[] bodyRaw = Encoding.UTF8.GetBytes(data.ToString());
            request.uploadHandler = (UploadHandler)new UploadHandlerRaw(bodyRaw);
        }

        request.downloadHandler = (DownloadHandler)new DownloadHandlerBuffer();
        request.SetRequestHeader("Content-Type", "application/json");
        request.SetRequestHeader("Authorization", Constants.AuthHeader);

        var pos = url.LastIndexOf('/');
        var route = url.Substring(pos + 1);
        Debug.Log($"DemoGame: sending {route} request");
        yield return request.SendWebRequest();

        Debug.Log("DemoGame: response: " + request.downloadHandler.text);
        if (callbackFunc != null)
        {
            callbackFunc(request.downloadHandler.text);
        }
    }

    public static string GetTruncatedWalletAddress()
    {
        string address = Globals.WalletAddress.Split(":")[2];
        string start = address.Substring(0, 8);
        string end = address.Substring(address.Length - 6);

        string truncatedAddress = $"{start}...{end}";

        return truncatedAddress;
    }

    public static string GetWalletAddress()
    {
        return Globals.WalletAddress.Split(":")[2];
    }

    public static void ShowAndroidToastMessage(string message)
    {
        AndroidJavaClass unityPlayer = new AndroidJavaClass("com.unity3d.player.UnityPlayer");
        AndroidJavaObject unityActivity = unityPlayer.GetStatic<AndroidJavaObject>("currentActivity");

        if (unityActivity != null)
        {
            AndroidJavaClass toastClass = new AndroidJavaClass("android.widget.Toast");
            unityActivity.Call("runOnUiThread", new AndroidJavaRunnable(() =>
            {
                AndroidJavaObject toastObject = toastClass.CallStatic<AndroidJavaObject>("makeText", unityActivity, message, 0);
                toastObject.Call("show");
            }));
        }
    }
}
